<i18n lang="yml">
en:
  container_types_and_pickups: "Trash types"
  container_residual: "Residual"
  container_bulky: "Bulky"
  container_paper: "Paper"
  container_plastic: "Plastic"
  container_pmd: "PMD"
  container_glass: "Glass"
  container_textile: "Textile"
  container_bread: "Bread"
  container_gft: "GFT"
  container_other: "Other"
  last_pickup: "Last pickup"
  next_pickup: "Next pickup"
  today: "Today"
  placements_from_last_scan: "Placements from last scan"
  cardboard: "Piece of cardboard | Pieces of cardboard"
  bags: "Trash bag | Trash bags"
  item_bulky: "Bulky"
  appliance: "Appliance | Appliances"
  carpet: "Carpet | Carpets"
  furniture: "Piece of furniture | Pieces of furniture"
  mattress: "Mattress | Mattresses"
  plastic: "Piece of plastic | Pieces of plastic"
  wood: "Piece of wood | Pieces of wood"
  last_scan: "Last scan"
  quarter: "Quarter"
  area: "Area"
  location_type: "ABP location type"
  problem_location: "Problem location"
  attention_location: "Attention location"
  other_location: "No ABP location"
  na: "N/A"
nl:
  container_types_and_pickups: "Afvalsoorten"
  container_residual: "Rest"
  container_bulky: "Grof"
  container_paper: "Papier"
  container_plastic: "Plastic"
  container_pmd: "PMD"
  container_glass: "Glas"
  container_textile: "Textiel"
  container_bread: "Brood"
  container_gft: "GFT"
  container_other: "Overig"
  last_pickup: "Laatste"
  next_pickup: "Volgende pickup"
  today: "Vandaag"
  placements_from_last_scan: "Bijplaatsingen van laatste scan"
  cardboard: "Stuk karton | Stukken karton"
  bags: "Afvalzak | Afvalzakken"
  item_bulky: "Grof"
  appliance: "Apparaat | Apparaten"
  carpet: "Tapijt | Tapijten"
  furniture: "Meubel | Meubels"
  mattress: "Matras | Matrassen"
  plastic: "Stuk plastic | Stukken plastic"
  wood: "Stuk hout | Stukken hout"
  last_scan: "Tijdstip"
  quarter: "Wijk"
  area: "Gebied"
  location_type: "ABP-locatietype"
  problem_location: "Probleemlocatie"
  attention_location: "Aandachtslocatie"
  other_location: "Geen ABP-locatie"
  na: "N.n.b."
</i18n>

<template>
  <div :class="$style['scandetails']">
    <div :class="$style['placements']">
      <div :class="$style['heading']">
        {{ $t("placements_from_last_scan") }}
      </div>
      <div :class="$style['icon']">
        <SvgIconBag />
      </div>
      <div :class="$style['placements-grid']">
        <div
          v-if="blocks.item_bags.value"
          :class="$style['block']"
        >
          <div :class="$style['block-head']">
            {{ blocks.item_bags.value }}
          </div>
          <div :class="$style['block-body']">
            {{ $tc('bags', blocks.item_bags.value) }}
          </div>
        </div>

        <div
          v-if="blocks.item_cardboard.value"
          :class="$style['block']"
        >
          <div :class="$style['block-head']">
            {{ blocks.item_cardboard.value }}
          </div>
          <div :class="$style['block-body']">
            {{ $tc('cardboard', blocks.item_cardboard.value) }}
          </div>
        </div>

        <template v-for="item in blocks.item_bulky.subValue">
          <div
            v-if="item.value > 0"
            :key="item.type"
            :class="$style['block']"
          >
            <div :class="$style['block-head']">
              {{ item.value }}
            </div>
            <div :class="$style['block-body']">
              {{ $tc(item.type, item.value) }}
            </div>
          </div>
        </template>
      </div>
    </div>

    <div :class="$style['containers']">
      <div :class="$style['heading']">
        {{ $t("container_types_and_pickups") }}
      </div>
      <div :class="$style['icon']">
        <SvgIconContainer />
      </div>
      <div :class="$style['containers-grid']">
        <template
          v-for="[key, value] of Object.entries(blocks.cluster_location.subValue.properties.cluster_fractie_aantal)"
        >
          <div
            v-for="v of value"
            :key="`${key}${v}`"
            :class="$style['block']"
          >
            <div :class="$style['block-head']">
              {{ $t(`container_${key}`) }}
            </div>
            <!-- @todo Get next pickup data from trash department and display it with the below block. -->
            <!-- <div :class="$style['block-body']">
              <div>
                <small>{{ $t("next_pickup") }}</small>
              </div>
              <div>
                {{ container.last_pickup ? container.last_pickup : $t("na") }}
              </div>
            </div> -->
          </div>
        </template>
      </div>
    </div>

    <div :class="$style['scandata']">
      <div v-if="blocks.last_scan">
        <h3>{{ $t("last_scan") }}</h3>
        <p>{{ dateTime.fromISO(blocks.last_scan.value).toFormat("HH:mm") }}</p>
      </div>

      <div>
        <h3>{{ $t("quarter") }}</h3>
        <p>{{ blocks.cluster_location.subValue.properties.quarter_name }}</p>
      </div>

      <div>
        <h3>{{ $t("area") }}</h3>
        <p>{{ blocks.cluster_location.subValue.properties.area_name }}</p>
      </div>

      <div>
        <h3>{{ $t("location_type") }}</h3>
        <p>{{ $t(blocks.location_type.value) }}</p>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
} from "@nuxtjs/composition-api";
import { DateTime } from "luxon";

export default defineComponent({
  name: "AmsScanDetails",

  components: {
    SvgIconContainer: () => import("~/assets/img/icons/underground_container.svg"),
    SvgIconBag: () => import("~/assets/img/icons/trash_bag.svg"),
  },

  props: {
    blocks: {
      type: Object,
      default: () => {},
    },
  },

  setup () {
    const dateTime = ref(DateTime);

    return {
      dateTime,
    };
  },
});
</script>

<style lang="postcss" module>
.scandetails {
  grid-template-rows: repeat(2, minmax(0, auto)) auto;
  padding-inline: 1.875rem;

  @apply grid grid-flow-col gap-3 py-8 w-full bg-white;

  .containers,
  .placements {
    grid: min-content minmax(0, 1fr) / 2.5rem minmax(0, auto);

    @apply grid gap-3 max-w-screen-lg;

    .heading {
      @apply col-span-2 mb-1 leading-none text-gray-700;
    }

    .icon {
      align-self: start;

      @apply flex justify-center items-center w-10 h-12 bg-blue-700 text-white;

      svg {
        width: 60%;
      }
    }

    &-grid {
      @apply flex flex-wrap w-full;

      .block {
        @apply flex mr-3 mb-3 h-12;

        &-head,
        &-body {
          @apply flex justify-center w-full;
        }

        &-head {
          width: min-content;

          @apply flex items-center pt-1 px-4 bg-blue-300 text-base text-blue-700 font-semibold;
        }

        &-body {
          @apply px-3 flex-col justify-center bg-gray-150 leading-none text-sm font-medium;

          small {
            font-size: 12px;

            @apply inline-block mb-2 font-normal text-gray-900;
          }
        }
      }
    }
  }

  .placements {
    .icon {
      @apply h-10;
    }

    &-grid {
      .block {
        min-width: 170px;

        @apply h-10;

        &-head {
          min-width: 2.5rem;
        }
      }
    }
  }

  .scandata {
    @apply flex flex-wrap;

    h3,
    p {
      @apply mr-6;
    }

    h3 {
      @apply text-gray-700;
    }

    p {
      @apply mb-3 font-medium whitespace-no-wrap;
    }
  }

}
</style>
